 /**   
    全屏等比(viewport width=720)适配脚本，请放入头部引用；

    适配问题：
    1. 在ios safari下，有时viewport宽度设置无效；这时默认为980，需要引起reflow，才能使得viewport生效；
    2. 主客中：
    * 小米2s在viewport无效，需要手动设置initial-scale；注意如果设置了 user-scalable=no，则scale无效；
    * ios下viewport无效，全部固定为device-width；
 */



 //var log = '';
;(function(win) {
   
    var html = document.documentElement,
        //获取clientWidth引起reflow；
        clientWidth = html.clientWidth,
        innerWidth = win.innerWidth;

    //log += innerWidth + '-' + clientWidth + '-';

    var scale = innerWidth / 720;

    //判断viewport设置是否生效
    if (scale != 1) {
        var metaEl = document.querySelector('meta[name="viewport"]');
        //使用比例设置
        metaEl.setAttribute('content','width=720,initial-scale=' + scale);
        //log += win.innerWidth + '-';
        if(win.innerWidth != 720){
            metaEl.setAttribute('content','width=device-width');
            //log += win.innerWidth + '-';
        }
    }

}(window));
